# Class OjSparkChart

The component WebElement for oj-spark-chart. Do not instantiate this class directly, instead, use ojSparkChart.

#### Hierarchy

- OjSparkChartBase
  - OjSparkChart

#####
Index

### Constructors

constructor

### Methods

clear
click
findElement
findElements
getAnimationDuration
getAnimationOnDataChange
getAnimationOnDisplay
getAreaColor
getAreaSvgClassName
getAreaSvgStyle
getAs
getAttribute
getBarGapRatio
getBaselineScaling
getColor
getCssValue
getDriver
getFirstColor
getHighColor
getId
getItems
getLastColor
getLineStyle
getLineType
getLineWidth
getLocation
getLowColor
getMarkerShape
getMarkerSize
getProperty
getRect
getReferenceObjects
getShadowRoot
getSize
getSvgClassName
getSvgStyle
getTagName
getText
getTooltip
getTrackResize
getTranslations
getType
getVisualEffects
hasSize
hasVisibility
isDisplayed
isEnabled
isSelected
sendKeys
serialize
setProperty
submit
takeScreenshot
whenBusyContextReady
whenReady
buildId
equals
extractId
isId

## Constructors

### constructor

- new OjSparkChart(el, locators): OjSparkChart

- Constructor. Pass an instance of WebDriver's WebElement that represents the DOM node on which we"ll perform operations.

  #### Parameters

  - ##### el: WebElement

    The basic WebElement with which this WebElement will work.

  - ##### locators: ElementLocators

  #### Returns OjSparkChart

  Inherited from OjSparkChartBase.constructor

## Methods

### clear

- clear(): Promise<void>

- ### Inherit Doc

  #### Returns Promise<void>

  Inherited from OjSparkChartBase.clear

### click

- click(): Promise<void>

- ### Inherit Doc

  #### Returns Promise<void>

  Inherited from OjSparkChartBase.click

### findElement

- findElement(locator): WebElementPromise

- ### Inherit Doc

  #### Parameters

  - ##### locator: Locator

  #### Returns WebElementPromise

  Inherited from OjSparkChartBase.findElement

### findElements

- findElements(locator): Promise<WebElement[]>

- ### Inherit Doc

  #### Parameters

  - ##### locator: Locator

  #### Returns Promise<WebElement[]>

  Inherited from OjSparkChartBase.findElements

### getAnimationDuration

- getAnimationDuration(): Promise<number>

- Gets the value of `animationDuration` property. The duration of the animations in milliseconds.

  #### Returns Promise<number>

  The value of `animationDuration` property.

  Inherited from OjSparkChartBase.getAnimationDuration

### getAnimationOnDataChange

- getAnimationOnDataChange(): Promise<string>

- Gets the value of `animationOnDataChange` property. Defines the animation that is applied on data changes.

  #### Returns Promise<string>

  The value of `animationOnDataChange` property.

  Inherited from OjSparkChartBase.getAnimationOnDataChange

### getAnimationOnDisplay

- getAnimationOnDisplay(): Promise<string>

- Gets the value of `animationOnDisplay` property. Defines the animation that is shown on initial display.

  #### Returns Promise<string>

  The value of `animationOnDisplay` property.

  Inherited from OjSparkChartBase.getAnimationOnDisplay

### getAreaColor

- getAreaColor(): Promise<string>

- Gets the value of `areaColor` property. The color of the area. Only applies if type is "area" or "lineWithArea".

  #### Returns Promise<string>

  The value of `areaColor` property.

  Inherited from OjSparkChartBase.getAreaColor

### getAreaSvgClassName

- getAreaSvgClassName(): Promise<string>

- Gets the value of `areaSvgClassName` property. The CSS style class to apply if type is "area" or "lineWithArea".

  #### Returns Promise<string>

  The value of `areaSvgClassName` property.

  Inherited from OjSparkChartBase.getAreaSvgClassName

### getAreaSvgStyle

- getAreaSvgStyle(): Promise<object>

- Gets the value of `areaSvgStyle` property. The inline style to apply if type is "area" or "lineWithArea".

  #### Returns Promise<object>

  The value of `areaSvgStyle` property.

  Inherited from OjSparkChartBase.getAreaSvgStyle

### getAs

- getAs(): Promise<string>

- Gets the value of `as` property. An alias for the '$current' context variable passed to slot content for the itemTemplate slot.

  ### Deprecated

  Since 6.2.0. Set the alias directly on the template element using the data-oj-as attribute instead.

  #### Returns Promise<string>

  The value of `as` property.

  Inherited from OjSparkChartBase.getAs

### getAttribute

- getAttribute(attributeName): Promise<string>

- ### Inherit Doc

  #### Parameters

  - ##### attributeName: string

  #### Returns Promise<string>

  Inherited from OjSparkChartBase.getAttribute

### getBarGapRatio

- getBarGapRatio(): Promise<number>

- Gets the value of `barGapRatio` property. Specifies the width of the bar gap as a ratio of the item width. The valid value is a number from 0 to 1.

  #### Returns Promise<number>

  The value of `barGapRatio` property.

  Inherited from OjSparkChartBase.getBarGapRatio

### getBaselineScaling

- getBaselineScaling(): Promise<string>

- Gets the value of `baselineScaling` property. Defines whether the axis baseline starts at the minimum value of the data or at zero.

  #### Returns Promise<string>

  The value of `baselineScaling` property.

  Inherited from OjSparkChartBase.getBaselineScaling

### getColor

- getColor(): Promise<string>

- Gets the value of `color` property. The color of the data items.

  #### Returns Promise<string>

  The value of `color` property.

  Inherited from OjSparkChartBase.getColor

### getCssValue

- getCssValue(cssStyleProperty): Promise<string>

- ### Inherit Doc

  #### Parameters

  - ##### cssStyleProperty: string

  #### Returns Promise<string>

  Inherited from OjSparkChartBase.getCssValue

### getDriver

- getDriver(): WebDriver

- #### Returns WebDriver

  The parent driver for this instance.

  Inherited from OjSparkChartBase.getDriver

### getFirstColor

- getFirstColor(): Promise<string>

- Gets the value of `firstColor` property. The color of the first data item.

  #### Returns Promise<string>

  The value of `firstColor` property.

  Inherited from OjSparkChartBase.getFirstColor

### getHighColor

- getHighColor(): Promise<string>

- Gets the value of `highColor` property. The color of the data item with the greatest value.

  #### Returns Promise<string>

  The value of `highColor` property.

  Inherited from OjSparkChartBase.getHighColor

### getId

- getId(): Promise<string>

- #### Returns Promise<string>

  A promise that resolves to the server-assigned opaque ID assigned to this element.

  Inherited from OjSparkChartBase.getId

### getItems

- getItems(): Promise<number[] | Items[]>

- Gets the value of `items` property. An array of objects that define the data for the spark chart. See the Help documentation for more information.

  #### Returns Promise<number[] | Items[]>

  The value of `items` property.

  Inherited from OjSparkChartBase.getItems

### getLastColor

- getLastColor(): Promise<string>

- Gets the value of `lastColor` property. The color of the last data item.

  #### Returns Promise<string>

  The value of `lastColor` property.

  Inherited from OjSparkChartBase.getLastColor

### getLineStyle

- getLineStyle(): Promise<string>

- Gets the value of `lineStyle` property. The line style of the data line. Only applies to line spark charts.

  #### Returns Promise<string>

  The value of `lineStyle` property.

  Inherited from OjSparkChartBase.getLineStyle

### getLineType

- getLineType(): Promise<string>

- Gets the value of `lineType` property. The line type of the data line or area. Only applies to line and area spark charts.

  #### Returns Promise<string>

  The value of `lineType` property.

  Inherited from OjSparkChartBase.getLineType

### getLineWidth

- getLineWidth(): Promise<number>

- Gets the value of `lineWidth` property. The width of the data line in pixels. Only applies to line spark charts.

  #### Returns Promise<number>

  The value of `lineWidth` property.

  Inherited from OjSparkChartBase.getLineWidth

### getLocation

- getLocation(): Promise<ILocation>

- ### Inherit Doc

  #### Returns Promise<ILocation>

  Inherited from OjSparkChartBase.getLocation

### getLowColor

- getLowColor(): Promise<string>

- Gets the value of `lowColor` property. The color of the data item with the lowest value.

  #### Returns Promise<string>

  The value of `lowColor` property.

  Inherited from OjSparkChartBase.getLowColor

### getMarkerShape

- getMarkerShape(): Promise<string>

- Gets the value of `markerShape` property. The shape of the data markers. See the Help documentation for more information.

  #### Returns Promise<string>

  The value of `markerShape` property.

  Inherited from OjSparkChartBase.getMarkerShape

### getMarkerSize

- getMarkerSize(): Promise<number>

- Gets the value of `markerSize` property. The size of the data markers in pixels. Only applies to line and area spark charts.

  #### Returns Promise<number>

  The value of `markerSize` property.

  Inherited from OjSparkChartBase.getMarkerSize

### getProperty

- getProperty<T>(propertyName): Promise<T>

- Get a named property value from this component. This function will wait for the application's busy context to complete before attempting to get the property value.

  #### Type Parameters

  - #### T = string

  #### Parameters

  - ##### propertyName: string

    The name of the property

  #### Returns Promise<T>

  A Promise that yields a value for the named property.

  Inherited from OjSparkChartBase.getProperty

### getRect

- getRect(): Promise<IRectangle>

- ### Inherit Doc

  #### Returns Promise<IRectangle>

  Inherited from OjSparkChartBase.getRect

### getReferenceObjects

- getReferenceObjects(): Promise<ReferenceObjects[]>

- Gets the value of `referenceObjects` property. An array of reference objects associated with the y axis of the spark chart.

  #### Returns Promise<ReferenceObjects[]>

  The value of `referenceObjects` property.

  Inherited from OjSparkChartBase.getReferenceObjects

### getShadowRoot

- getShadowRoot(): ShadowRootPromise

- Get the shadow root of the current web element.

  #### Returns ShadowRootPromise

  A promise that will be resolved with the elements shadow root or rejected with NoSuchShadowRootError

  Inherited from OjSparkChartBase.getShadowRoot

### getSize

- getSize(): Promise<ISize>

- ### Inherit Doc

  #### Returns Promise<ISize>

  Inherited from OjSparkChartBase.getSize

### getSvgClassName

- getSvgClassName(): Promise<string>

- Gets the value of `svgClassName` property. The CSS style class to apply to the data items. If type is "lineWithArea", this style will only be applied to the line if areaSvgClassName is also specified. See the Help documentation for more information.

  #### Returns Promise<string>

  The value of `svgClassName` property.

  Inherited from OjSparkChartBase.getSvgClassName

### getSvgStyle

- getSvgStyle(): Promise<object>

- Gets the value of `svgStyle` property. The inline style to apply to the data items. If type is "lineWithArea", this style will only be applied to the line if areaSvgStyle is also specified. See the Help documentation for more information.

  #### Returns Promise<object>

  The value of `svgStyle` property.

  Inherited from OjSparkChartBase.getSvgStyle

### getTagName

- getTagName(): Promise<string>

- Schedules a command to query for the tag/node name of this element.

  #### Returns Promise<string>

  A promise that will be resolved with the element's tag name.

  Inherited from OjSparkChartBase.getTagName

### getText

- getText(): Promise<string>

- ### Inherit Doc

  #### Returns Promise<string>

  Inherited from OjSparkChartBase.getText

### getTooltip

- getTooltip(): Promise<Tooltip>

- Gets the value of `tooltip` property. An object containing an optional callback function for tooltip customization.

  #### Returns Promise<Tooltip>

  The value of `tooltip` property.

  Inherited from OjSparkChartBase.getTooltip

### getTrackResize

- getTrackResize(): Promise<string>

- Gets the value of `trackResize` property. Defines whether the element will automatically render in response to changes in size. See the Help documentation for more information.

  #### Returns Promise<string>

  The value of `trackResize` property.

  Inherited from OjSparkChartBase.getTrackResize

### getTranslations

- getTranslations(): Promise<Translations>

- Gets the value of `translations` property. A collection of translated resources from the translation bundle, or null if this component has no resources.

  #### Returns Promise<Translations>

  The value of `translations` property.

  Inherited from OjSparkChartBase.getTranslations

### getType

- getType(): Promise<string>

- Gets the value of `type` property. The chart type.

  #### Returns Promise<string>

  The value of `type` property.

  Inherited from OjSparkChartBase.getType

### getVisualEffects

- getVisualEffects(): Promise<string>

- Gets the value of `visualEffects` property. Defines whether visual effects such as overlays are applied to the spark chart.

  #### Returns Promise<string>

  The value of `visualEffects` property.

  Inherited from OjSparkChartBase.getVisualEffects

### `Protected` hasSize

- hasSize(): Condition<Promise<boolean>>

- Create a wait condition that is satisfied when the element's DOM has a non-zero size.

  ### Deprecated

  Since 11.0.0. Call the appropriate WebElement method to test the size of the element.

  #### Returns Condition<Promise<boolean>>

  The Condition to be used with driver.wait() that's satisfied when the element's DOM has a non-zero size.

  Inherited from OjSparkChartBase.hasSize

### `Protected` hasVisibility

- hasVisibility(): Condition<Promise<boolean>>

- Create a wait condition that is satisfid when the element is visible. The condition is satisfied when the element is displayed, as reported by #isDisplayed, and is scrolled into view. This is method is deprecated. Use WebElement.isDisplayed instead to test the display of the element, and scroll it into view if necessary.

  ### Deprecated

  #### Returns Condition<Promise<boolean>>

  Inherited from OjSparkChartBase.hasVisibility

### isDisplayed

- isDisplayed(): Promise<boolean>

- ### Inherit Doc

  #### Returns Promise<boolean>

  Inherited from OjSparkChartBase.isDisplayed

### isEnabled

- isEnabled(): Promise<boolean>

- ### Inherit Doc

  #### Returns Promise<boolean>

  Inherited from OjSparkChartBase.isEnabled

### isSelected

- isSelected(): Promise<boolean>

- ### Inherit Doc

  #### Returns Promise<boolean>

  Inherited from OjSparkChartBase.isSelected

### sendKeys

- sendKeys(...varArgs): Promise<void>

- ### Inherit Doc

  #### Parameters

  - ##### `Rest` ...varArgs: (string | number | Promise<string | number>)[]

  #### Returns Promise<void>

  Inherited from OjSparkChartBase.sendKeys

### serialize

- serialize(): Promise<IWebElementId>

- #### Returns Promise<IWebElementId>

  Inherited from OjSparkChartBase.serialize

### `Protected` setProperty

- setProperty<T>(propertyName, value): Promise<void>

- Set a property value on the remote element. This function first waits for the BusyContext to clear before setting the property, then after setting, waits again to ensure that no additional busy states were created due to the property setting.

  #### Type Parameters

  - #### T = string

  #### Parameters

  - ##### propertyName: string

    The property name to set

  - ##### value: T

    The value to set for the property

  #### Returns Promise<void>

  A Promise which resolves when the remote property has been set to the value. Any value returned from the call to set the remote property is returned in the Promise.

  Inherited from OjSparkChartBase.setProperty

### submit

- submit(): Promise<void>

- ### Inherit Doc

  #### Returns Promise<void>

  Inherited from OjSparkChartBase.submit

### takeScreenshot

- takeScreenshot(optScroll?): Promise<string>

- ### Inherit Doc

  #### Parameters

  - ##### `Optional` optScroll: boolean

  #### Returns Promise<string>

  Inherited from OjSparkChartBase.takeScreenshot

### whenBusyContextReady

- whenBusyContextReady(): Promise<void>

- Returns a Promise that is resolved when the application's busy state reports ready. This method checks only that the application's busy context is ready, and not that the DOM element is actually displayed or has a physical size, such as is the case with #whenReady. Operations which are read-only in nature should call this method prior to execution.

  #### Returns Promise<void>

  A Promise which is resolved when the page's busy state is ready.

  Inherited from OjSparkChartBase.whenBusyContextReady

### whenReady

- whenReady(): Promise<void>

- Returns a Promise that is resolved when the element is ready for interaction--it is visible, has a size, and the app's busy context is ready. Operations on the DOM which rely on its physical location and size to be in a "ready" state should use this command, such as clicking, sending keys, locating child elements, and so on.

  #### Returns Promise<void>

  A Promise that's resolved when all conditions are met.

  Inherited from OjSparkChartBase.whenReady

### `Static` buildId

- buildId(id, opt_noLegacy?): IWebElementId

- #### Parameters

  - ##### id: string

    The raw ID.

  - ##### `Optional` opt_noLegacy: boolean

    Whether to exclude the legacy element key.

  #### Returns IWebElementId

  The element ID for use with WebDriver's wire protocol.

  Inherited from OjSparkChartBase.buildId

### `Static` equals

- equals(a, b): Promise<boolean>

- Compares two WebElements for equality.

  #### Parameters

  - ##### a: WebElement

    A WebElement.

  - ##### b: WebElement

    A WebElement.

  #### Returns Promise<boolean>

  A promise that will be resolved to whether the two WebElements are equal.

  Inherited from OjSparkChartBase.equals

### `Static` extractId

- extractId(obj): string

- Extracts the encoded WebElement ID from the object.

  ### Throws

  if the object is not a valid encoded ID.

  #### Parameters

  - ##### obj: IWebElementId

    The object to extract the ID from.

  #### Returns string

  the extracted ID.

  Inherited from OjSparkChartBase.extractId

### `Static` isId

- isId(obj): boolean

- #### Parameters

  - ##### obj: IWebElementId

    the object to test.

  #### Returns boolean

  whether the object is a valid encoded WebElement ID.

  Inherited from OjSparkChartBase.isId

Generated using TypeDoc